{*******************************************************}
{                                                       }
{       Extension Library                               }
{       Strin List Editor dialog Unit                   }
{                                                       }
{       (c) 2002, Balabuyev Yevgeny                     }
{       E-mail: stalcer@rambler.ru                      }
{                                                       }
{*******************************************************}

unit ELStringsEdit;

interface

uses
  Windows, Messages, SysUtils {$IFDEF VER140} , Variants {$ENDIF} , Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, ComCtrls, ExtCtrls, Menus;

var
  SELStringsEditorDlgCaption: string              = 'String List Editor';
  SELStringsEditorDlgOkBtnCaption: string         = '&Ok';
  SELStringsEditorDlgCancelBtnCaption: string     = 'Cancel';
  SELStringsEditorDlgLinesCountTemplate: string   = '%d lines';

type
  TELStringsEditorDlg = class(TForm)
    btnOk: TButton;
    btnCancel: TButton;
    lbLineCount: TLabel;
    bvlMain: TBevel;
    memMain: TRichEdit;
    PopupMenu: TPopupMenu;
    menuLoad: TMenuItem;
    menuSave: TMenuItem;
    N1: TMenuItem;
    menuPaste: TMenuItem;
    menuCut: TMenuItem;
    procedure memMainChange(Sender: TObject);
    procedure PopupMenuPopup(Sender: TObject);
    procedure menuLoadClick(Sender: TObject);
    procedure menuSaveClick(Sender: TObject);
  private
    function GetLines: TStrings;
    procedure SetLines(const Value: TStrings);
  public
    function Execute: Boolean;
    property Lines: TStrings read GetLines write SetLines;
  end;

implementation

{$R *.dfm}

{ TELStringsEditorDlg }

function TELStringsEditorDlg.Execute: Boolean;
begin
  Caption := SELStringsEditorDlgCaption;
  btnOk.Caption := SELStringsEditorDlgOkBtnCaption;
  btnCancel.Caption := SELStringsEditorDlgCancelBtnCaption;
  lbLineCount.Caption := Format(SELStringsEditorDlgLinesCountTemplate,
    [memMain.Lines.Count]);

  Result := (ShowModal = mrOk);
end;

function TELStringsEditorDlg.GetLines: TStrings;
begin
  Result := memMain.Lines;
end;

procedure TELStringsEditorDlg.SetLines(const Value: TStrings);
begin
  memMain.Lines := Value;
end;

procedure TELStringsEditorDlg.memMainChange(Sender: TObject);
begin
  lbLineCount.Caption := Format(SELStringsEditorDlgLinesCountTemplate,
    [memMain.Lines.Count]);
end;

procedure TELStringsEditorDlg.PopupMenuPopup(Sender: TObject);
begin
    menuCut.Enabled := (memMain.SelText<>'');
end;

procedure TELStringsEditorDlg.menuLoadClick(Sender: TObject);
begin
   with TOpenDialog.Create(nil) do begin
        if Execute then
           memMain.Lines.LoadFromFile(FileName);
        Free;
   end;
end;

procedure TELStringsEditorDlg.menuSaveClick(Sender: TObject);
begin
   with TSaveDialog.Create(nil) do begin
        if Execute then
           memMain.Lines.SaveToFile(FileName);
        Free;
   end;
end;

end.
